package example.android.contentprovideraccesssample1;

import android.app.Activity;
import android.content.ContentValues;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;

public class ContentProviderAccessSample1Activity extends Activity {
    // onCreate\bh(ʏ\Cxgnh)
    @Override
    public void onCreate(Bundle savedInstanceState) {
        // X[p[NXonCreate\bhĂяo
        super.onCreate(savedInstanceState);
        // CAEgݒt@C̎w
        setContentView(R.layout.accesssample1);
        
        // o^{^̃NbNXi[ݒ
        Button insertBtn = (Button)findViewById(R.id.insert);
        insertBtn.setTag("insert");
        insertBtn.setOnClickListener(new ButtonClickListener());
        // \{^̃NbNXi[ݒ
        Button selectBtn = (Button)findViewById(R.id.select); 
        selectBtn.setTag("select");
        selectBtn.setOnClickListener(new ButtonClickListener());
    }
    
    // NbNXi[`
    class ButtonClickListener implements OnClickListener {
    	// onClick\bh({^NbNCxgnh)
    	public void onClick(View v){
    		// ^O̎擾
    		String tag = (String)v.getTag();
    		
    		// bZ[W\p
            String message  = "";
            TextView label = (TextView)findViewById(R.id.message);
            
            // ͏擾
			EditText productid = (EditText)findViewById(R.id.id);
            EditText name = (EditText)findViewById(R.id.name);
            EditText price = (EditText)findViewById(R.id.price);
            
            // Uri擾
            Uri uri = Uri.parse("content://example.android.contentprovidersample1");
            
            // e[uCAEgIuWFNg擾
            TableLayout tablelayout = (TableLayout)findViewById(R.id.list);

            // e[uCAEg̃NA
            tablelayout.removeAllViews();
    		
    		// o^{^ꂽꍇ
    		if(tag.equals("insert")){
                
                // f[^o^
                try{
                    // o^f[^ݒ
                    ContentValues val = new ContentValues();
                    val.put("productid", productid.getText().toString());
                    val.put("name", "***" + name.getText().toString() + "***");
                    val.put("price", price.getText().toString());
                    // f[^o^
                    getContentResolver().insert(uri, val);
                	// bZ[Wݒ
                    message += "f[^o^܂I";

                }catch(Exception e){
                	message  = "f[^o^Ɏs܂I";
                	Log.e("ERROR",e.toString());
                } 
                
            // \{^ꂽꍇ
    		}else if(tag.equals("select")){
                
                // f[^擾
                try{                   
                    // f[^擾
                    Cursor cursor = managedQuery(uri, null, null, null, null);
                    
                    // e[uCAEg̕\͈͂ݒ
                    tablelayout.setStretchAllColumns(true);
                    
                    // e[uꗗ̃wb_ݒ
                    TableRow headrow = new TableRow(ContentProviderAccessSample1Activity.this);
                    TextView headtxt1 = new TextView(ContentProviderAccessSample1Activity.this);
                    headtxt1.setText("iID");
                    headtxt1.setGravity(Gravity.CENTER_HORIZONTAL);
                    headtxt1.setWidth(60);
                    TextView headtxt2 = new TextView(ContentProviderAccessSample1Activity.this);
                    headtxt2.setText("i");
                    headtxt2.setGravity(Gravity.CENTER_HORIZONTAL);
                    headtxt2.setWidth(100);
                    TextView headtxt3 = new TextView(ContentProviderAccessSample1Activity.this);
                    headtxt3.setText("i");
                    headtxt3.setGravity(Gravity.CENTER_HORIZONTAL);
                    headtxt3.setWidth(60);          
                    headrow.addView(headtxt1);
                    headrow.addView(headtxt2);
                    headrow.addView(headtxt3);
                    tablelayout.addView(headrow);
                    
                    // 擾f[^e[uוɐݒ
                    while(cursor.moveToNext()){                	
                        
                        TableRow row = new TableRow(ContentProviderAccessSample1Activity.this);
                        TextView productidtxt = new TextView(ContentProviderAccessSample1Activity.this);
                        productidtxt.setGravity(Gravity.CENTER_HORIZONTAL);
                        productidtxt.setText(cursor.getString(1));
                        TextView nametxt = new TextView(ContentProviderAccessSample1Activity.this);
                        nametxt.setGravity(Gravity.CENTER_HORIZONTAL);
                        nametxt.setText(cursor.getString(2));
                        TextView pricetxt = new TextView(ContentProviderAccessSample1Activity.this);
                        pricetxt.setGravity(Gravity.CENTER_HORIZONTAL);
                        pricetxt.setText(cursor.getString(3));
                        row.addView(productidtxt);
                        row.addView(nametxt);
                        row.addView(pricetxt);
                        tablelayout.addView(row);
                        
                        // bZ[Wݒ
                        message = "f[^擾܂I";
                    }
             
                }catch(Exception e){
                	// bZ[Wݒ
                    message = "f[^擾Ɏs܂I";
                    Log.e("ERROR",e.toString());
                }      
    		}           
            // bZ[W\  
            label.setText(message);
    	}
    }
}