package example.android.optionmenusample;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.SubMenu;

public class OptionMenuSampleActivity extends Activity {
    // onCreate\bh(ʏ\Cxgnh)
    @Override
    public void onCreate(Bundle savedInstanceState) {
        // X[p[NXonCreate\bhĂяo
        super.onCreate(savedInstanceState);
        // CAEgݒt@C̎w
        setContentView(R.layout.optionmenusample);        
    }
    
    // onCreateOptionsMenu\bh(IvVj[)
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        
        // j[ACe1̒ǉ
        @SuppressWarnings("unused")
		MenuItem item1=menu.add(0,0,0,"item1");
        
        // j[ACe2̒ǉ
        MenuItem item2=menu.add(0,1,0,"item2");
        item2.setIcon(android.R.drawable.ic_menu_search);
        
        // j[ACe3̒ǉ
        MenuItem item3=menu.add(0,2,0,"item3");
        item3.setIcon(android.R.drawable.ic_menu_save);
        
        //j[ACe4̒ǉ ǉ
        MenuItem item4=menu.add(0,3,0,"item4");
        item4.setIcon(android.R.drawable.ic_menu_call);
        
        //j[ACe5̒ǉ ǉ
        MenuItem item5=menu.add(0,4,0,"item5");
        item5.setIcon(android.R.drawable.ic_menu_camera);
        
        //j[ACe6̒ǉ ǉ
        SubMenu item6=menu.addSubMenu(0,5,0,"̑");
        item6.setIcon(android.R.drawable.ic_menu_more);
        item6.add(0,10,0,"subitem1");
        item6.add(0,20,0,"subitem2");

        return true;
    }    

    // onOptionsItemSelected\bh(j[ACeI)
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case 0:
                showDialog("j[ACe1I܂B");
                return true;
            case 1:
                showDialog("j[ACe2I܂B");
                return true;
            case 2:
                showDialog("j[ACe3I܂B");
                return true;
            case 3:
                showDialog("j[ACe4I܂B");
                return true;
            case 4:
                showDialog("j[ACe5I܂B");
                return true;
            case 10:
                showDialog("Tuj[ACe1I܂B");
                return true;
            case 20:
                showDialog("Tuj[ACe2I܂B");
                return true;            
        }
        return true;
    }    
    
    // showDialog\bh(_CAO\)
    private void showDialog(String text) {
        AlertDialog.Builder dialog=new AlertDialog.Builder(OptionMenuSampleActivity.this);
        dialog.setTitle("j[ACeI");
        dialog.setMessage(text);
        dialog.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
            	OptionMenuSampleActivity.this.setResult(Activity.RESULT_OK);
            }
        });
        dialog.create();
        dialog.show();
    }
}