package example.android.greeting;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class GreetingActivity extends Activity {
    // onCreate\bh(ʏ\Cxgnh)
    @Override
    public void onCreate(Bundle savedInstanceState) {
        // X[p[NXonCreate\bhĂяo
        super.onCreate(savedInstanceState);
        // CAEgݒt@C̎w
        setContentView(R.layout.greeting);
        
        // {^IuWFNg擾
        Button button = (Button) findViewById(R.id.button1);       
        // {^IuWFNgɃNbNXi[ݒ
        button.setOnClickListener(new ButtonClickListener());
    }
    // NbNXi[`
    class ButtonClickListener implements OnClickListener {
        // onClick\bh({^NbNCxgnh)
        public void onClick(View arg0) {
            
            // ͒l̎擾
            EditText input = (EditText)findViewById(R.id.hourtext);
            
            // Ceg̐
            Intent intent = new Intent(Intent.ACTION_VIEW);
            
            // ͒l̐U蕪
            int time = 0;
            try {
                time = Integer.parseInt(input.getText().toString());
            } catch (NumberFormatException e) {
                // ͏g[Xg@\ŉʕ\
                Toast.makeText(GreetingActivity.this, "sȒl͂܂I",Toast.LENGTH_SHORT).show();
                // vȌI
                return ;
    
            }
            
            String text = "";
            String prefix = "";
            if (time >= 4 && time <= 12) {      
                text = "͂悤I";
                prefix = "goodmorning";
            } else if (time >= 13 && time <= 18) {
                text = "ɂ́I";
                prefix = "goodafternoon";
            } else if ( (time >= 19 && time <= 24) || (time >= 1 && time <= 3)) {
                text = "΂I";
                prefix = "goodevening";
            } else {
                // ͏g[Xg@\ŉʕ\
                Toast.makeText(GreetingActivity.this, "sȒl͂܂I",Toast.LENGTH_SHORT).show();
                // vȌI
                return ;
            }
            
            // URIݒ
            Uri uri = Uri.parse("intentmondai:///"+prefix+"?greeting=" + text);
            
            // URICegɐݒ
            intent.setData(uri);
            
            // ̃ANeBreB̋N
            startActivity(intent);  
        }
        
    }
}